
   /*$RCSfile: validateDatetime.js,v $ $Revision: 1.1 $ $Date: 2008/09/30 12:26:08 $ */
    /**
    * Check to see if fields are a valid date.
    * Fields are not checked if they are disabled.
    * <p>
    * @param form The form validation is taking place on.
    */
    function validateDatetime(form) {
       var bValid = true;
       var focusField = null;
       var i = 0;
       var fields = new Array();
       var formName = form.getAttributeNode("name"); 

       oDate = eval('new ' + formName.value + '_DatetimeValidations()');

       for (x in oDate) {
           var field = form[oDate[x][0]];
           var value = field.value;
           var datePattern = oDate[x][2]("datePatternStrict");
           // try loose pattern
           if (datePattern == null)
               datePattern = oDate[x][2]("datePattern");
           if ((field.type == 'hidden' ||
                field.type == 'text' ||
                field.type == 'textarea') &&
               (value.length > 0) && (datePattern.length > 0) &&
                field.disabled == false) {
                 var MONTH = "MM";
                 var DAY = "dd";
                 var YEAR = "yyyy";
                 var HOUR = "HH";
                 var MINUTE = "mm";
                 var SECOND = "ss";
                 var orderMonth = datePattern.indexOf(MONTH);
                 var orderDay = datePattern.indexOf(DAY);
                 var orderYear = datePattern.indexOf(YEAR);
                 var orderHour = datePattern.indexOf(HOUR);
                 var orderMinute = datePattern.indexOf(MINUTE);
                 var orderSecond = datePattern.indexOf(SECOND);
                 if ((orderDay < orderYear && orderDay > orderMonth)) {
                     var iDelim1 = orderMonth + MONTH.length;
                     var iDelim2 = orderDay + DAY.length;
                     var iDelim3 = orderYear + YEAR.length;
                     var iDelim4 = orderHour + HOUR.length;
                     var iDelim5 = orderMinute + MINUTE.length;
                     var delim1 = datePattern.substring(iDelim1, iDelim1 + 1);
                     var delim2 = datePattern.substring(iDelim2, iDelim2 + 1);
                     var delim3 = datePattern.substring(iDelim3, iDelim3 + 1);
                     var delim4 = datePattern.substring(iDelim4, iDelim4 + 1);
                     var delim5 = datePattern.substring(iDelim5, iDelim5 + 1);
                     
                     var regStr = "";
                     if (iDelim1 == orderDay && iDelim2 == orderYear) {
                         regStr = "^(\\d{2})(\\d{2})(\\d{4})";
                     } else if (iDelim1 == orderDay) {
                        regStr = "^(\\d{2})(\\d{2})[" + delim2 + "](\\d{4})";
                     } else if (iDelim2 == orderYear) {
                        regStr = "^(\\d{2})[" + delim1 + "](\\d{2})(\\d{4})";
                     } else {
                        regStr = "^(\\d{2})[" + delim1 + "](\\d{2})[" + delim2 + "](\\d{4})";
                     }
					 if( iDelim3 == orderHour ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim3 + "](\\d{2})";
					 }
					 if( iDelim4 == orderMinute ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim4 + "](\\d{2})";
					 }
					 if( iDelim5 == orderSecond ) {
	                     regStr = regStr + "(\\d{2})$";
					 } else {
	                     regStr = regStr + "[" + delim5 + "](\\d{2})$";
					 }
                     dateRegexp = new RegExp( regStr );
                     var matched = dateRegexp.exec(value);
                     if(matched != null) {
                        if (!isValidDatetime(matched[2], matched[1], matched[3], matched[4], matched[5], matched[6])) {
                           if (i == 0) {
                               focusField = field;
                           }
                           fields[i++] = oDate[x][1];
                           bValid =  false;
                        }
                     } else {
                        if (i == 0) {
                            focusField = field;
                        }
                        fields[i++] = oDate[x][1];
                        bValid =  false;
                     }
                     
                 } else if ((orderMonth < orderYear && orderMonth > orderDay)) {
                     var iDelim1 = orderDay + DAY.length;
                     var iDelim2 = orderMonth + MONTH.length;
                     var iDelim3 = orderYear + YEAR.length;
                     var iDelim4 = orderHour + HOUR.length;
                     var iDelim5 = orderMinute + MINUTE.length;
                     var delim1 = datePattern.substring(iDelim1, iDelim1 + 1);
                     var delim2 = datePattern.substring(iDelim2, iDelim2 + 1);
                     var delim3 = datePattern.substring(iDelim3, iDelim3 + 1);
                     var delim4 = datePattern.substring(iDelim4, iDelim4 + 1);
                     var delim5 = datePattern.substring(iDelim5, iDelim5 + 1);

                     var regStr = "";
                     if (iDelim1 == orderMonth && iDelim2 == orderYear) {
                         regStr = "^(\\d{2})(\\d{2})(\\d{4})";
                     } else if (iDelim1 == orderMonth) {
                         regStr = "^(\\d{2})(\\d{2})[" + delim2 + "](\\d{4})";
                     } else if (iDelim2 == orderYear) {
                         regStr = "^(\\d{2})[" + delim1 + "](\\d{2})(\\d{4})";
                     } else {
                         regStr = "^(\\d{2})[" + delim1 + "](\\d{2})[" + delim2 + "](\\d{4})";
                     }
					 if( iDelim3 == orderHour ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim3 + "](\\d{2})";
					 }
					 if( iDelim4 == orderMinute ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim4 + "](\\d{2})";
					 }
					 if( iDelim5 == orderSecond ) {
	                     regStr = regStr + "(\\d{2})$";
					 } else {
	                     regStr = regStr + "[" + delim5 + "](\\d{2})$";
					 }
                     dateRegexp = new RegExp( regStr );
                     var matched = dateRegexp.exec(value);
                     if(matched != null) {
                         if (!isValidDate(matched[1], matched[2], matched[3], matched[4], matched[5], matched[6])) {
                             if (i == 0) {
                         focusField = field;
                             }
                             fields[i++] = oDate[x][1];
                             bValid =  false;
                          }
                     } else {
                         if (i == 0) {
                             focusField = field;
                         }
                         fields[i++] = oDate[x][1];
                         bValid =  false;
                     }
                     
                 } else if ((orderMonth > orderYear && orderMonth < orderDay)) {
                     var iDelim1 = orderYear + YEAR.length;
                     var iDelim2 = orderMonth + MONTH.length;
                     var iDelim3 = orderDay + DAY.length;
                     var iDelim4 = orderHour + HOUR.length;
                     var iDelim5 = orderMinute + MINUTE.length;
                     var delim1 = datePattern.substring(iDelim1, iDelim1 + 1);
                     var delim2 = datePattern.substring(iDelim2, iDelim2 + 1);
                     var delim3 = datePattern.substring(iDelim3, iDelim3 + 1);
                     var delim4 = datePattern.substring(iDelim4, iDelim4 + 1);
                     var delim5 = datePattern.substring(iDelim5, iDelim5 + 1);

                     var regStr = "";
                     if (iDelim1 == orderMonth && iDelim2 == orderDay) {
                         regStr = "^(\\d{4})(\\d{2})(\\d{2})";
                     } else if (iDelim1 == orderMonth) {
                         regStr = "^(\\d{4})(\\d{2})[" + delim2 + "](\\d{2})";
                     } else if (iDelim2 == orderDay) {
                         regStr = "^(\\d{4})[" + delim1 + "](\\d{2})(\\d{2})";
                     } else {
                         regStr = "^(\\d{4})[" + delim1 + "](\\d{2})[" + delim2 + "](\\d{2})";
                     }
					 if( iDelim3 == orderHour ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim3 + "](\\d{2})";
					 }
					 if( iDelim4 == orderMinute ) {
	                     regStr = regStr + "(\\d{2})";
					 } else {
	                     regStr = regStr + "[" + delim4 + "](\\d{2})";
					 }
					 if( iDelim5 == orderSecond ) {
	                     regStr = regStr + "(\\d{2})$";
					 } else {
	                     regStr = regStr + "[" + delim5 + "](\\d{2})$";
					 }
                     dateRegexp = new RegExp( regStr );
                     var matched = dateRegexp.exec(value);

                     if(matched != null) {
                         if (!isValidDate(matched[3], matched[2], matched[1], matched[4], matched[5], matched[6])) {
                             if (i == 0) {
                                 focusField = field;
                             }
                             fields[i++] = oDate[x][1];
                             bValid =  false;
                         }
                     } else {
                          if (i == 0) {
                              focusField = field;
                          }
                          fields[i++] = oDate[x][1];
                          bValid =  false;
                     }
                     
                 } else {
                     if (i == 0) {
                         focusField = field;
                     }
                     fields[i++] = oDate[x][1];
                     bValid =  false;
                 }
          }
       }
       if (fields.length > 0) {
          focusField.focus();
          alert(fields.join('\n'));
       }
       return bValid;
    }
    
    function isValidDatetime(day, month, year, hour, minute, second) {
	    if (month < 1 || month > 12) {
            return false;
        }
        if (day < 1 || day > 31) {
            return false;
        }
        if ((month == 4 || month == 6 || month == 9 || month == 11) &&
            (day == 31)) {
            return false;
        }
        if (month == 2) {
            var leap = (year % 4 == 0 &&
               (year % 100 != 0 || year % 400 == 0));
            if (day>29 || (day == 29 && !leap)) {
                return false;
            }
        }
        if( hour < 0 && hour > 23 ){
            return false;
        }
        if( minute < 0 && minute > 59 ){
            return false;
        }
        if( second < 0 && second > 59 ){
            return false;
        }
        return true;
    }
    
    